// vlastne triedy
#include "OGLcamera.h"
#include "OGLobjects.h"
#include "OGLtext.h"
#include "OGLtexture.h"
#include "glTerrain.h"

// trieda pre pracu s OpenGL
typedef struct __material { // struktura OpenGL materialu
 GLfloat amb[4],dif[4],spe[4],amb_dif[4],emi[4];
 GLfloat shi,transp,sillum[4];
} _material;

typedef struct __light {    // struktura OpenGL svetla
 GLfloat amb[4],dif[4],spe[4];
 GLfloat pos[4],spot[3];
} _light;

// trieda premennych a funkcii pre pracu s OpenGL
class COGL {
public:
 COGL();                      // konstruktor
 virtual ~COGL();             // destruktor

 COGLcamera ogl_camera[8];    // pouzite kamery
 COGLobjects ogl_object;      // pouzite jednoduche objekty
 COGLtext ogl_text;           // instancia triedy COGLtext - praca s textom
 COGLtexture ogl_texture;     // instancia triedy COGLtexture - praca s texturou

 glTerrain ogl_terrain; // instancia triedy glTerrain - teren

 GLuint ogl_lighting;         // zapnutie/vypnutie osvetlenia

 bool gl_initialize(void);    // inicializacia OpenGL
 GLubyte gl_draw(void);       // vykreslenie OpenGL sceny

 void change_PolygonMode(void); // zmena sposobu zobrazenia objektov
 void change_FogMode(void);     // zmena parametrov hmly
 void change_TexMode(void);     // zmena pouzitia texturovania

 GLuint normals_mode;
 void change_NormalsMode(void); // zmena vykreslovania normal

 GLuint cam_mode;
 void change_CamMode(void);     // zmena pohladu
private:
 _material ogl_material[8];   // pouzite materialy
 _light ogl_light[8];         // pouzite svetla

 GLuint t_a,t_b; // pomocne premenne

 GLfloat rot_x,rot_y; // rotacne uhly

 GLuint	DL_id[5]; // identifikatory display listov

 GLfloat ogl_fogColor[4]; // farba hmly

 GLint ogl_state[2]; // zistovanie stavov OpenGL stavoveho stroja
};

